/*
 * SourceMod Radio
 *
 * Adds a radio player to SourceMod that supports direct station links or streaming audio
 *
 * Coded by dubbeh - www.dubbeh.net
 *
 * Licensed under the GPLv3
 *
 */


void PrintPrimaryGenreList(int iClient)
{
	int iIndex = 0;
	int iCount = 0;
	char szGenreName[64] = "";
	char szBuffer[512] = "";
	
	for (iIndex = 0, iCount = 0; iIndex < g_Genres.iCount; iIndex++) {
		
		if (g_Genres.GetParentID(iIndex) == 0) {
			
			g_Genres.GetName(iIndex, szGenreName, sizeof(szGenreName));
			
			if ((iIndex + 2) == g_Genres.iCount) {
				StrCat(szBuffer, sizeof(szBuffer), szGenreName);
			} else {
				StrCat(szBuffer, sizeof(szBuffer), szGenreName);
				StrCat(szBuffer, sizeof(szBuffer), ", ");
			}
			
			iCount++;
			
			if (iCount == 10) {
				CReplyToCommand(iClient, szBuffer);
				clear_string(szBuffer, strlen(szBuffer));
				iCount = 0;
			}
		}
	}
	
	if (iCount < 10) {
		CReplyToCommand(iClient, szBuffer);
	}
}

void clear_string(char[] szBuffer, int iLen)
{
	int iIndex = 0;
	
	for (iIndex = 0; iIndex <= iLen; iIndex++) {
		szBuffer[iIndex] = 0;
	}
}

int FindPrimaryGenreIndexByName(char[] szGenreName)
{
	char szCompareGenreName[64] = "";
	int iIndex = 0;
	
	for (iIndex = 0; iIndex < g_Genres.iCount; iIndex++) {
		if (g_Genres.GetParentID(iIndex) == 0) {
			g_Genres.GetName(iIndex, szCompareGenreName, sizeof(szCompareGenreName));
			if (!strcmp(szGenreName, szCompareGenreName, false))
				return iIndex;
		}
	}
	
	return 0;
}

void BrowseURL(int iClient, char[] szURL)
{
	if (g_EngineVersion == Engine_CSGO)
		CReplyToCommand(iClient, "Browse command unsupported in CS:GO");
	else
		ShowMOTDPanel(iClient, "SourceMod Browse", szURL, MOTDPANEL_TYPE_URL);
}

void LoadStation(int iClient, char []szStationID, bool bCustomShoutCast)
{
	int iStationID = 0;
	int iStationIndex = 0;
	char szBuffer[MAX_MOTD_URL_SIZE] = "";
	char szStreamURL[128] = "";
	char szStationName[64] = "";
	
	if (((iStationID = StringToInt(szStationID)) > 0) && IsClientConnected(iClient) && IsClientInGame(iClient))
	{
		if (g_iRadioPlayType == RADIO_PLAY_TYPE_SHOUTCAST)
		{
			if (bCustomShoutCast)
			{
				iStationIndex = GetCustomStationIndexFromID(iStationID);
				if (g_CustStations.IsValid(iStationIndex))
				{
					g_CustStations.GetStreamURL(iStationIndex, szStreamURL, sizeof(szStreamURL));
					if (szStreamURL[0])
					{
						ShowMOTDFromURL(iClient, RadioVolumeWrapper(iClient, szStreamURL, GetClientStationVolume(iClient)));
						SetClientCookiesForStation(iClient, szStationID, bCustomShoutCast);
						
						if (g_cVarStationAdvert.IntValue)
						{
							g_CustStations.GetName(iStationIndex, szStationName, sizeof(szStationName));
							AdvertiseStationChoice(iClient, szStationName);
						}
					} else {
						LogMessage(g_szNoStreamURLSet, g_CustStations.GetID(iStationIndex));
					}
				} else {
					LogMessage(g_szInvalidStationIndex);
				}
			} else {
				iStationIndex = GetStationIndexFromID(iStationID);
				if (g_Stations.IsValid(iStationIndex))
				{
					Format(szBuffer, sizeof(szBuffer), "%s?sid=%d&mod=%d&vol=%s", g_szShoutCastURL, g_Stations.GetID(iStationIndex), g_EngineVersion, GetClientStationVolume(iClient));
					ShowMOTDFromURL(iClient, szBuffer);
					SetClientCookiesForStation(iClient, szStationID, bCustomShoutCast);
					if (g_cVarStationAdvert.IntValue)
					{
						g_Stations.GetName(iStationIndex, szStationName, sizeof(szStationName));
						AdvertiseStationChoice(iClient, szStationName);
					}
				} else {
					LogMessage(g_szInvalidStationIndex);
				}
			}
		}
		else if (g_iRadioPlayType == RADIO_PLAY_TYPE_DIRECT)
		{
			iStationIndex = GetStationIndexFromID(iStationID);
			if (g_Stations.IsValid(iStationIndex))
			{
				g_Stations.GetStreamURL(iStationIndex, szStreamURL, sizeof(szStreamURL));
				if (szStreamURL[0])
				{
					ShowMOTDFromURL(iClient, szStreamURL);
					SetClientCookiesForStation(iClient, szStationID, bCustomShoutCast);
					if (g_cVarStationAdvert.IntValue)
					{
						g_Stations.GetName(iStationIndex, szStationName, sizeof(szStationName));
						AdvertiseStationChoice(iClient, szStationName);
					}
				} else {
					LogMessage(g_szNoStreamURLSet, g_Stations.GetID(iStationIndex));
				}
			} else {
				LogMessage(g_szInvalidStationIndex);
			}
		}
		else if (g_iRadioPlayType == RADIO_PLAY_TYPE_VOLUME_CONTROL)
		{
			iStationIndex = GetStationIndexFromID(iStationID);
			if (g_Stations.IsValid(iStationIndex))
			{
				g_Stations.GetStreamURL(iStationIndex, szStreamURL, sizeof(szStreamURL));
				if (szStreamURL[0])
				{
					ShowMOTDFromURL(iClient, RadioVolumeWrapper(iClient, szStreamURL, GetClientStationVolume(iClient)));
					SetClientCookiesForStation(iClient, szStationID, bCustomShoutCast);
					if (g_cVarStationAdvert.IntValue)
					{
						g_Stations.GetName(iStationIndex, szStationName, sizeof(szStationName));
						AdvertiseStationChoice(iClient, szStationName);
					}
				} else {
					LogMessage(g_szNoStreamURLSet, g_Stations.GetID(iStationIndex));
				}
			} else {
				LogMessage(g_szInvalidStationIndex);
			}
		}
	}
}

void SetClientCookiesForStation(int iClient, char[] szStationID, bool bIsCustom)
{
	char szPlayType[8] = "";

	SetClientCookie(iClient, g_hCookieSavedStationID, szStationID);
	
	if (bIsCustom)
		SetClientCookie(iClient, g_hCookieIsCustomShoutCast, "1");
	else
		SetClientCookie(iClient, g_hCookieIsCustomShoutCast, "0");
	
	IntToString(g_iRadioPlayType, szPlayType, sizeof(szPlayType));
	SetClientCookie(iClient, g_hCookieRadioPlayType, szPlayType);
}

void AdvertiseStationChoice(int iClient, char[] szStationName)
{
	char szClientName[MAX_NAME_LENGTH + 1];
	
	GetClientName(iClient, szClientName, sizeof(szClientName));
	CPrintToChatAll("%T", "Started Listening", LANG_SERVER, szClientName, szStationName);
}

char GetClientStationVolume(int iClient)
{
	char szStationVolume[12] = "";
	
	GetClientCookie(iClient, g_hCookieSavedVolumeLevel, szStationVolume, sizeof(szStationVolume));
	if (!szStationVolume[0])
	{
		FloatToString(g_cVarInitialConnectVolume.FloatValue, szStationVolume, sizeof(szStationVolume));
		SetClientCookie(iClient, g_hCookieSavedVolumeLevel, szStationVolume);
	}
	
	return szStationVolume;
}

void ShowMOTDFromURL(int iClient, char[] szURL)
{
	if (!IsClientConnected(iClient) || !IsClientInGame(iClient))
		return;
	
	if (g_EngineVersion == Engine_CSGO)
		LoadMOTDPanel(iClient, PLUGIN_NAME, szURL, true);
	else
		ShowMOTDPanel(iClient, PLUGIN_NAME, szURL, MOTDPANEL_TYPE_URL);
}

char RadioVolumeWrapper(int iClient, char[] szStationURL, char[] szVolume)
{
	char szURL[256] = "";
	
	Format(szURL, sizeof(szURL), "%s?url=%s&volume=%s", g_szVolumeWrapperURL, szStationURL, szVolume);
	IsURLTooLong(iClient, szURL);
	return szURL;
}

void IsURLTooLong(int iClient, char[] szURL)
{
	if (IsClientConnected(iClient) && IsClientInGame(iClient))
	{
		if (strlen(szURL) > MAX_MOTD_URL_SIZE)
		{
			LogMessage("[SM-RADIO] Warning: URL \"%s\" exceeds the 192 bytes limit and will end up truncated.", szURL);
			CPrintToChat(iClient, "%T", "Radio URL Too Long", LANG_SERVER);
		}
	}
}


void LoadOffPage(int iClient)
{
	char szClientName[MAX_NAME_LENGTH + 1] = "";
	
	if (IsClientConnected(iClient) && IsClientInGame(iClient))
	{
		LoadMOTDPanel(iClient, "SourceMod Radio", g_szRadioOffPage, true);
		SetClientCookie(iClient, g_hCookieRadioPlayType, "0");
		SetClientCookie(iClient, g_hCookieSavedStationID, "");
		
		if (g_cVarStationAdvert.IntValue)
		{
			GetClientName(iClient, szClientName, sizeof(szClientName));
			CPrintToChatAll("%T", "Stopped Listening", LANG_SERVER, szClientName);
		}
	}
}

void LoadMOTDPanel(int iClient, char[] szTitle, char[] szPage, bool bHidden)
{
	if (!IsClientConnected(iClient) || !IsClientInGame(iClient))
		return;
	
	Handle kv = INVALID_HANDLE;
	
	kv = CreateKeyValues("data");
	
	KvSetString(kv, "title", szTitle);
	KvSetNum(kv, "type", MOTDPANEL_TYPE_URL);
	KvSetString(kv, "msg", szPage);
	KvSetNum(kv, "cmd", 0); //http://forums.alliedmods.net/showthread.php?p=1220212
	ShowVGUIPanel(iClient, "info", kv, bHidden);
	CloseHandle(kv);
}

int GetGenreIndexFromID(int iGenreID)
{
	for (int iIndex = 0; iIndex < g_Genres.iCount; iIndex++) {
		if (g_Genres.GetID(iIndex) == iGenreID)
			return iIndex;
	}
	return -1;
}

int GetCustomGenreIndexFromID(int iGenreID)
{
	for (int iIndex = 0; iIndex < g_CustGenres.iCount; iIndex++) {
		if (g_CustGenres.GetID(iIndex) == iGenreID)
			return iIndex;
	}
	return -1;
}

int GetStationIndexFromID(int iStationID)
{
	for (int iIndex = 0; iIndex < g_Stations.iCount; iIndex++) {
		if (g_Stations.GetID(iIndex) == iStationID)
			return iIndex;
	}
	return -1;
}

int GetCustomStationIndexFromID(int iStationID)
{
	for (int iIndex = 0; iIndex < g_CustStations.iCount; iIndex++) {
		if (g_CustStations.GetID(iIndex) == iStationID)
			return iIndex;
	}
	return -1;
}

void LoadStationFromCookie (int iClient)
{
	char szStationID[32] = "";
	char szTemp[8] = "";
	int iCookiePlayType = 0;
	bool bIsCustomShoutCast = false;
	
	if (AreClientCookiesCached(iClient))
	{
		GetClientCookie(iClient, g_hCookieRadioPlayType, szTemp, sizeof(szTemp));
		iCookiePlayType = StringToInt(szTemp);
		GetClientCookie(iClient, g_hCookieSavedStationID, szStationID, sizeof(szStationID));

		// Make sure we only load stations that are saved from the correct playtype
		// Check the playtype is correct and a Station ID is set aka. Station ID > 0
		if (g_iRadioPlayType == iCookiePlayType && szStationID[0])
		{
			GetClientCookie(iClient, g_hCookieIsCustomShoutCast, szTemp, sizeof(szTemp));
			bIsCustomShoutCast = view_as<bool>(StringToInt(szTemp));
			
			// Is the station saved as ShoutCast Custom and custom playlists enabled?
			if (bIsCustomShoutCast && g_cVarShoutCastCustom.BoolValue) {
			    LoadStation(iClient, szStationID, true);
			} else {
			    LoadStation(iClient, szStationID, false);
			}
		}
	}
}
